################################################################################
#                    www.PowerShell-Scripting.com
#
#                      PowerShell Form Converter package
#
# Version : 0.8
#
# Statut  : A valider
#
# Date    : 26 mars 2008
#
# Nom     : PackageConvert-Form.ps1
#
# Usage   : . .\PackageConvert-Form.ps1
#
# Objet   : Regroupe une srie de fonctions en relation avec le script Convert-Form
#			(conversion d'un formulaire graphique C# en un script PowerShell).
# 
# Limitations :
#
# Todo    :
#			
#
##########################################################################
Function Load-Assembly([System.Collections.ArrayList] $Liste, [String[]] $Assemblies)
{ #Charge une liste d'assemblies .NET
 foreach ($Assembly in $Assemblies) 
  { [void]$Liste.Add("[void][Reflection.Assembly]::LoadWithPartialName(`"$Assembly`")") }
 [void]$Liste.Add("")
}

Function Create-Header([String] $NomScript)
{ #Cre l'entte du script

 $Date="{0:d}" -f [DateTime]::Today #Format JJ/MM/AAAA
 $Line ="#" * 80
 
  #Le @ permet des commentaires multiligne car les lignes de log d'un gestionnaire de source 
  # peuvent tre consquente. Ces info de logs devrait tre placs en fin de fichier sources..
  # Doc SVN: http://svnbook.red-bean.com/en/1.1/ch07s02.html#svn-ch-7-sect-2.3.4
  $Begin="@`""
  $Redirection="`"@`>`$Null"
# Here-string  
#Dbute par @" et se termine par "@  (ou  @' '@ dans ce cas pas de substitution)
#Certains caractres utiliss par PS doivent tre "chapp", exemple : $ # @ >
@"
$Line 
`#
`#  Nom     : $NomScript
`#  Version : 0.1
`#  Auteur  :
`#  Date    : le $Date
$Begin
Historique :
(Soit substitution CVS)
`$Log`$
(soit substitution SVN)
`$LastChangedDate`$
`$Rev`$
$Redirection 
`#
$Line

"@
}

Function Create-EventComponent([String] $ComponentName, [String] $EventName)
{ #Cre et ajoute un vnement d'un composant.
  #Par dfaut le scriptbloc gnr affiche un message d'information

  $UnderConstruction = "[void][System.Windows.Forms.MessageBox]::Show(`"L'vnement $ComponentName.Add_$EventName n'est pas implment.`")"
   #La syntaxe d'ajout d'un dlgu est : Add_NomEvnment 
   # o le nom de l'vnement est celui du SDK .NET
   #On double le caractre '{' afin de pouvoir l'afficher
  $OnEvent_Name="On{0}_{1}" -f ($EventName,$ComponentName)
  $Fonction ="function $OnEvent_Name(`$Sender,`$e){{`r`n`t{0}`r`n}}`r`n" -f ($UnderConstruction)
  $EvtHdl= "`${0}.Add_{1}( {{ {2} `${0} `$EventArgs}} )" -f ($ComponentName, $EventName, $OnEvent_Name)
# Here-string    
@"
 $Fonction
 $EvtHdl
"@
}

function Add-SpecialEventForm([String] $FormName)
{ # Ajoute des mthodes d'vnement spcifique  la forme principale
  #FormClosing
    # Permet  l'utilisateur de : 
    #   -dterminer la cause de la fermeture
    #   -autoriser ou non la fermeture

 $Entte = "function OnFormClosing_{0}(`$Sender,`$e){{" -f ($FormName)
 $Close  = "`${0}.Add_FormClosing( {{ OnFormClosing_{0} `${0} `$EventArgs}} )" -f ($FormName)

  #FormShown
   #Replace au premier plan la fentre en l'activant. By /\/\o\/\/
   # Form1.topmost=$true est inoprant
 $Shown  = "`${0}.Add_Shown({{`${0}.Activate()}})" -f ($FormName)

# Here-string  
@"
$Entte 
`t# `$this est gal au paramtre sender (object)
`t# `$_ est gal au paramtre  e (eventarg)

`t# Dterminer la raison de la fermeture :
`t#   if ((`$_).CloseReason -eq [System.Windows.Forms.CloseReason]::UserClosing)

`t#Autorise la fermeture
`t(`$_).Cancel= `$False
}
$Close
$Shown
"@
}

function AjouteGestionRessources
{ #Ajoute le code grant un fichier de ressources et ce  l'aide d'une "here-string"
  # 1 fonction
  # 2 test d'existence du fichier
  # 3 rcupration dans une hastable des ressources de la Winform

# Here-string    
@"
function Get-ScriptDirectory
{  #Renvoi le nom du rpertoire d'un script parent, celui appel sur la ligne de commande.
   # By J.Snover
  `$Invocation = (Get-Variable MyInvocation -Scope 1).Value
  Split-Path `$Invocation.MyCommand.Path
}
`$ScriptPath = Get-ScriptDirectory
`$RessourcesPath= Join-Path `$ScriptPath "$FormName.resources"
if ( !(Test-Path `$RessourcesPath))
 {
  Write-Warning "Le fichier suivant n'existe pas :`n`r `$RessourcesPath"
  break; # Sinon le script est en exception qq lignes plus tard
 }
  #Gestion du fichier des ressources
`$Reader = new-Object System.Resources.ResourceReader("`$RessourcesPath")
`$Ressources=@{}
`$Reader.GetEnumerator()|% {`$Ressources.(`$_.Name)=`$_.value}
 
 # Cration des composants
"@         
}

function ConvertirEnum([String] $Enumeration)
{ #Converti une valeur d'numration
  # un.deux.trois en [un.deux]::trois
 $Enumeration = $Enumeration.trim()
  # recherche (et capture) en fin de chane un mot prcd d'un point lui-mme prcd de n'importe quel caractres
 $Enumeration -replace "(.*)\.(\w+)$", '[$1]::$2'
}

function ParseParametreEnumeration([String]$NomEnumeration, [String] $Parametres)
{ #Voir le fichier  "..\Documentations\Analyse des proprits.txt"
 #Gre les proprits Font et Anchor

  $Valeurs= $Parametres.Split("|")
  $NbValeur = $Valeurs.Count
   
   #Une seule valeur, on la convertie
  if ($NbValeur -eq 1 )
   { return ConvertirEnum $Parametres} 

   #Valeur 1 :
   #         ((Nom.Enumeration)((Nom.Enumeration.VALEUR
    # recherche (et capture) en fin de chane un mot prcd d'un point lui-mme prcd de n'importe quel caractres
 $Valeurs[0]= ($Valeurs[0] -replace "^.*\.(.*)$", '$1').Trim()
 
   #Valeur 2..n :
   #     Nom.Enumeration.VALEUR)    
   # recherche (et capture) en fin de chane une parenthse prcde de caractres uniquement prcds d'un point lui-mme prcd de n'importe quel caractres
 for ($i=1;$i -le $NbValeur-2;$i++)
  { $Valeurs[$i]= ($Valeurs[$i] -replace "^.*\.([a-zA-Z]*)\)$", '$1').Trim() }

   #Dernire valeur  :
   #         Nom.Enumeration.VALEUR))  
   # ou      Nom.Enumeration.VALEUR)))  
   # recherche (et capture) en fin de chane deux parenthses prcdes de caractres uniquement prcds d'un point lui-mme prcd de n'importe quel caractres
 $Valeurs[$NbValeur-1]= ($Valeurs[$NbValeur-1] -replace "^.*\.([a-zA-Z]*)\)*", '$1').Trim()
 Return "[$NomEnumeration]`"{0}`"" -F ([string]::join(",", $Valeurs))
}

function ParseProprieteFONT([System.Text.RegularExpressions.Match] $MatchStr)
{ #Analyse une dclaration d'une proprit Font
   #Pour la chane:  $label1.Font = New-Object System.Drawing.Font("Arial Black", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)))
	# $MatchStr contient 4 groupes :
	#  0- la ligne complte
	#  1- $label1
	#  2- .Font = New-Object System.Drawing.Font(
	#  3- "Arial Black", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0))

    #Rcupre les paramtres du constructeur
  $Parametres= [Regex]::Split($MatchStr.Groups[3].value,",")
  $nbParam=$Parametres.count #toto inutile
    #Le premier est tjr le nom de la fonte de caractre
    #Le second est tjr la taille de la fonte de caractre dans ce cas on supprime le caractre 'F' 
    #indiquant un type double
  $Parametres[1]=$Parametres[1] -replace "F",''
  
   #Teste les diffrentes signatures de constructeurs
   ##On parcourt toute la liste du nombre de paramtre possibles, les uns  la suite des autres.
  Switch ($Parametres.count)
  { 
    {$_ -eq 3} {  #Est-ce un paramtre de type System.Drawing.GraphicsUnit ?
                 if ( $Parametres[2].Contains("System.Drawing.GraphicsUnit") )
         		   {$Parametres[2]=ConvertirEnum $Parametres[2]}
         		   #si non c'est donc un paramtre de type System.Drawing.FontStyle ?
       			 else { $Parametres[2]=ParseParametreEnumeration "System.Drawing.FontStyle" $Parametres[2] }
     		   }

    {$_ -ge 4} {  #Le troisime est tjr de type FontStyle
   	   			  #Le quatrime est tjr de type GraphicsUnit
                 $Parametres[2]= ParseParametreEnumeration "System.Drawing.FontStyle" $Parametres[2]
                 $Parametres[3]=ConvertirEnum $Parametres[3]
               }
                 
    {$_ -ge 5} {  #On rcupre uniquement la valeur du paramtre : ((byte)(123))
                  # Un ou plusieurs chiffres :                        [0-9]+
                 $Parametres[4]=$Parametres[4] -replace "\(\(byte\)\(([0-9]+)\)\)", '$1' 
               }

    #6 Le sixime (true - false) est trait par la suite dans le script principal

                  #Pb :/
    {$_ -ge 7} { throw ("Cas imprvu : {0}" -f ($MatchStr.Groups[3].value)) }
  }
  
  return $Parametres
}
function ParseProprieteANCHOR([System.Text.RegularExpressions.Match] $MatchStr)
{ #Analyse une dclaration d'une proprit Anchor
   #Pour la chane: $comboBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)| System.Windows.Forms.AnchorStyles.Left)| System.Windows.Forms.AnchorStyles.Right)));

	# $MatchStr contient 4 groupes :
	#  0- la ligne complte
	#  1- $comboBox1
	#  2- .Anchor = ((System.Windows.Forms.AnchorStyles)
	#  3- (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)| System.Windows.Forms.AnchorStyles.Left)| System.Windows.Forms.AnchorStyles.Right));

 #Peut tre cod dans l'appelant mais cela documente un peu plus
 return ParseParametreEnumeration "System.Windows.Forms.AnchorStyles" $MatchStr.Groups[3].value
}

function ParseProprieteSHORTcutKeys([System.Text.RegularExpressions.Match] $MatchStr)
{ #Analyse une dclaration d'une proprit ShortcutKeys
   #Pour la chane: this.toolStripMenuItem2.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Alt | System.Windows.Forms.Keys.A)));

	# $MatchStr contient 4 groupes :
	#  0- la ligne complte
	#  1- $comboBox1
	#  2- .ShortcutKeys = ((System.Windows.Forms.Keys)
	#  3- ((System.Windows.Forms.Keys.Alt | System.Windows.Forms.Keys.A)));

 #Peut tre cod dans l'appelant mais cela documente un peu plus
 return ParseParametreEnumeration "System.Windows.Forms.Keys" $MatchStr.Groups[3].value
}

function ParseParametres_rgb([System.Text.RegularExpressions.Match] $MatchStr)
{ #Analyse les paramtres d'un appel de la mthode FromArgb
   #Pour la chane:  $CaseCocher.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))))
	# $MatchStr contient 4 groupes :
	#  0- la ligne complte
	#  1- $CaseCocher.FlatAppearance.MouseDownBackColor
	#  2-  = System.Drawing.Color.FromArgb(
	#  3- ((int)(((byte)(192)))), ((int)(((byte)(255)))), ((int)(((byte)(192))))
	 
    #Rcupre les 3 paramtres
  $Parametres= [Regex]::Split($MatchStr.Groups[3].value,",")
  for ($i=0; $i -lt $Parametres.count; $i++)
	  # On rcupre uniquement la valeur du paramtre : ((int)(((byte)(192))))
	  #Recherche ( et capture) en dbut de chaine une suite de caractre suivis d'une parenthse suivi de 
	  #un ou plusieurs chiffres suivis par une ou plusieurs parenthses
   { $Parametres[$i]=$Parametres[$i]  -replace "^(.*)\(([0-9]+)\)+", '$2' }
   
  return $Parametres
}

function ReConstruitGroups([System.Text.RegularExpressions.Match] $MatchStr, [Array] $NumerosOrdonnes)
 {  #On reconstruit le dbut d'une chaine  partir d'une expression parse
   # $NumerosOrdonnes : Contient les numros des groupes  insrer dans la nouvelle chane
   $Result=new-object System.Text.StringBuilder
   foreach ($Num in $NumerosOrdonnes)
    {
      [void]$Result.Append($MatchStr.Groups[$Num].value)
    }
   return $Result
 }
 
function ReconstruitLigne([System.Text.RegularExpressions.Match] $MatchStr, [Array] $NumerosOrdonnes,[string[]] $Parametres )
{ #Utilis pour reconstruire une propriet.

   #On reconstruit l'intgralit d'un chane parse et transforme
  $Sb=ReConstruitGroups $MatchStr $NumerosOrdonnes
  [void]$Sb.Append( [string]::join(",", $Parametres)) 
  return $Sb.ToString()
}

function MakeFilesName
{ #Construit les paths et noms des fichier  partir de $Source et $Destination
 
   #Le fichier de ressource possde une autre construction que le nom du fichier source
   # en entre                 : C:\VS\Projet\PS\Form1.Designer.cs C:\Temp\Destination.ps1
   # fichier ressource associ : C:\VS\Projet\PS\Form1.resx        
   # fichier ressource gnr  : C:\Temp\Form1.ressources
   # fichier de log gnr     : C:\Temp\Destination.Log
  $global:SourcePath = Split-Path $Source
  $global:SourceName = ([System.IO.Path]::GetFilenameWithoutExtension($Source)) -replace ".designer",''
  if ($global:SourcePath -eq [String]::Empty)
   {  #Le fichier source  se trouve dans le rpertoire d'excution de ce script
     $global:SourcePath =$ScriptPath}
 
  $global:DestinationPath = Split-Path $Destination
  $global:DestinationName = ([System.IO.Path]::GetFilenameWithoutExtension($Source))
  if ($global:DestinationPath -eq [String]::Empty) #Evite les coquilles:  " " au lieu de ""
   {$global:DestinationPath =$ScriptPath}
 }

function CompileRessources
{ #Compile le fichier contenant les ressources d'un formulaire, ex : Form1.resx 

   #On gnre le fichier de ressources
  $Resgen=Join-Path $ScriptPath "ResGen.exe" 
  if ( !(Test-Path $Resgen))
   { write-host "Le gnrateur de ressources est introuvable : $Resgen" -F DarkYellow }
  else
   {
	 $SrcResx = Join-Path $SourcePath ($SourceName+".resx")
	 if ( !(Test-Path $SrcResx))
	  { Write-Host "Le fichier de ressources est introuvable : $SrcResx" -F DarkYellow }
	 else
	  {
	   $DestResx = Join-Path $DestinationPath ($SourceName+".resources")
	   $Log=Join-Path $DestinationPath ("$DestinationName.log")
	   if ((Test-Path $Log))
	     { 
	       trap  
            {Write-Warning "Suppression du fichier impossible : $Log"; Continue}
	       Remove-Item $Log 
	     }
	   
	    #Redirige le handle d'erreur vers le handle standard de sortie
	   $ResultExec=.$Resgen $SrcResx $DestResx 2>&1
	   $ResultExec|Out-File -width 999 $Log
	   if ($LastExitCode -ne 0)
	    { Write-Warning "Erreur($LastExitCode) lors de la gnration du fichier de ressources . Consultez le fichier de log"}
	   else { Write-Host "Gnration du fichier de ressources." -F Green }
	  }
   } 
}
